program Mapv1;

{ By  : TothPaul@mygale.org }

{ From: aurel@xylo.owl.de (Aurel Balmosan) - original.txt }

{ Ce programme montre deux mthodes pour crer une carte
 (mer/sable/fort/montagne).

 La premire, "PLASMA", est tire de Pascalissime n66, un article de
 Patrick Ruelle sur un moteur COMMANCHE.

 Pour la deuxime, voir ORIGINAL.TXT.
 Le principe de cette deuxime mthode est de couper la carte en deux
 (breakmap) pour augmenter de 1 l'altitude sur la premire moti et la baisser
 de 1 sur l'autre. En rptant cette opration un grand nombre de fois, on
 obtient un paysage.

{ Aurel optimise le code en conservant uniquement les deltas :

 au lieu de coder dans map :

   -1-1-1-1+1+1+1+1+1
   -1-1-1+1+1+1+1+1+1
   -1-1+1+1+1+1+1+1+1
   -1+1+1+1+1+1+1+1+1

 il code

 -1        +2          en lisant de gauche  droite, on a bien -1... jusque
 -1      +2            (-1+2) qui donne +1...
 -1    +2
 -1  +2


}

{$R-,S-,I-,Q-}

uses
 crt;

const
 WIDTH =160;
 HEIGHT=180;
 RANGE =255;

var
 map :array[0..HEIGHT-1,0..WIDTH-1] of byte;

procedure drawmap(ofs:word); assembler;
 asm
  mov es,SegA000
  mov di,ofs

  mov si,offset map

  mov dx,HEIGHT
 @nextline:
  mov cx,WIDTH/2
  rep movsw
  add di,320-WIDTH
 dec dx
 jnz @nextline
 end;


procedure plasma(x1,y1,x2,y2:word); { d'aprs Patrick Ruelle - Pascalissime 66 }

 function color(mc,n,dvd:integer):byte;
  begin
   color:=(mc+n-Random(2*n)) div dvd;
  end;

 var
  xn,yn,dxy,p1,p2,p3,p4:word;
 begin
  if (x2-x1<2)and(y2-y1<2) then exit;
  p1:=map[y1,x1];
  p2:=map[y2,x1];
  p3:=map[y1,x2];
  p4:=map[y2,x2];
  xn:=(x2+x1) shr 1;
  yn:=(y2+y1) shr 1;
  dxy:=(x2-x1+y2-y1) * 5 div 3 ;
  if map[y1,xn]=0 then map[y1,xn]:=Color(p1+p3,dxy,2);
  if map[yn,x1]=0 then map[yn,x1]:=Color(p1+p2,dxy,2);
  if map[yn,x2]=0 then map[yn,x2]:=Color(p3+p4,dxy,2);
  if map[y2,xn]=0 then map[y2,xn]:=Color(p2+p4,dxy,2);
  map[yn,xn]:=color(p1+p2+p3+p4,dxy,4);

  if (x2-x1)>10 then drawmap(8*320); (* affiche la carte en cours de construction *)

  plasma(x1,y1,xn,yn);
  plasma(xn,y1,x2,yn);
  plasma(x1,yn,xn,y2);
  plasma(xn,yn,x2,y2);
 end;

procedure xline(x,y,dx,dy,ix,iy,i:integer);
 var
  error:integer;
  yy:integer;
 begin
  error:=dy;
  while (x>=0)and(x<WIDTH) do begin
   for yy:=0 to y do if byte(map[yy,x]+i)<RANGE then inc(map[yy,x],i);
   for yy:=y+1 to HEIGHT-1 do if byte(map[yy,x]-i)<RANGE then dec(map[yy,x],i);
   inc(x,ix);
   inc(error,dy);
   if error>dx then begin
    dec(error,dx);
    inc(y,iy);
    if (y<0)or(y>=HEIGHT) then begin
     if y<0 then i:=-i;
     if ix<0 then begin
      dx:=0; ix:=x;
     end else begin
      dx:=x; ix:=WIDTH-1;
     end;
     for x:=dx to ix do begin
      for yy:=0 to HEIGHT-1 do if byte(map[yy,x]+i)<RANGE then inc(map[yy,x],i);
     end;
     break;
    end;
   end;
  end;
 end;

procedure yline(x,y,dx,dy,ix,iy,i:integer);
 var
  error:integer;
  xx:integer;
 begin
  error:=dx;
  while (y>=0)and(y<HEIGHT) do begin
   for xx:=0 to x do if byte(map[y,xx]+i)<RANGE then inc(map[y,xx],i);
   for xx:=x+1 to WIDTH-1 do if byte(map[y,xx]-i)<RANGE then dec(map[y,xx],i);
   inc(y,iy);
   inc(error,dx);
   if error>dy then begin
    dec(error,dy);
    inc(x,ix);
    if (x<0)or(x>=WIDTH) then begin
     if x<0 then i:=-i;
     if iy<0 then begin
      dy:=0; iy:=y;
     end else begin
      dy:=y; iy:=HEIGHT-1;
     end;
     for y:=dy to iy do
      for xx:=0 to WIDTH-1 do if byte(map[y,xx]+i)<RANGE then inc(map[y,xx],i);
     break;
    end;
   end;
  end;
 end;

procedure breakmap(x1,y1,x2,y2:integer);
 var
  dx,dy:integer;
  ix,iy:integer;
  error:word;
  loop :word;
  yy   :integer;
 begin

  dx:=x2-x1; if dx<0 then begin ix:=-1; dx:=-dx; end else ix:=+1;
  dy:=y2-y1; if dy<0 then begin iy:=-1; dy:=-dy; end else iy:=+1;

  if dx>dy then begin
   xline(x1,y1,dx,dy,ix,iy,ix);
   xline(x1-ix,y1,dx,dy,-ix,-iy,ix);
  end else begin
   yline(x1,y1,dx,dy,ix,iy,iy);
   yline(x1,y1-iy,dx,dy,-ix,-iy,iy);
  end;

 end;

var
 i:word;

begin
 asm mov ax,13h; int 10h end;

 directvideo:=false;
 textattr:=255;
 gotoxy( 8, 1); write('PLASMA');
 gotoxy(26, 1); write('MANDELBROT');
 gotoxy( 5,25); write('http://www.mygale.org\~TothPaul');

 randomize;

 port[$3c8]:=0;
 for i:=0 to 63 do begin
  port[$3c9]:=0;
  port[$3c9]:=0;
  port[$3c9]:=i; { blue }
 end;
 for i:=0 to 63 do begin
  port[$3c9]:=63-i div 2; { yellow }
  port[$3c9]:=63-i div 2;
  port[$3c9]:=0;
 end;
 for i:=0 to 63 do begin
  port[$3c9]:=0;
  port[$3c9]:=63-i div 2; { green }
  port[$3c9]:=0;
 end;
 for i:=0 to 63 do begin
  port[$3c9]:=i;
  port[$3c9]:=i;
  port[$3c9]:=i;
 end;

{ Plasma }
 fillchar(map,sizeof(map),0);
 plasma(0,0,width-1,height-1);

 drawmap(8*320);

{ Mandelbrot }

 fillchar(map,sizeof(map),128); (* comment this ! *)
 for i:=0 to 3000 do begin
  breakmap(random(WIDTH),random(HEIGHT),random(WIDTH),random(HEIGHT));
  drawmap(8*320+WIDTH);
  if keypressed then begin readkey; break; end;
 end;

 readkey;

 asm mov ax,03h; int 10h end;
end.